#INCLUDE "dcdialog.CH"
#INCLUDE "XCodeJock.CH"
#INCLUDE "CommandBars.CH"
#INCLUDE "fileio.CH"
#INCLUDE "dcbitmap.CH"
#INCLUDE "appevent.CH"
*#INCLUDE "Definitions.CH"
#INCLUDE "SkinFramework.CH"
#INCLUDE "TaskPanel.ch"

#DEFINE TRUE  .t.
#DEFINE FALSE .f.

#define ON .t.
#define OFF .f.
#Pragma Library("ascom10.lib")
#Pragma Library("XCodeJock.lib")

** comment one
#define WITHTOOLBAR  1
*#define WITHBROWSE 1


FUNCTION Main()

LOCAL Getlist[0], Getoptions, oCommandBars, oImageManager, oStatic, oTabToolBar, ;
      nTheme, oDlg, oBrowse, aDir := Directory(), oTimer, oAppWindow, ;
      cLicense:=""

*cSkinDLL:="Office2007Black.dll"
cSkinDLL:="Office2007Blue.dll"
TP_VisualTheme:=xtpTaskPanelThemeShortcutBarOffice2007

oCmdGlobSett := CreateObject('Codejock.CommandBarsGlobalSettings'+CJ_Version())
oCmdGlobSett:Office2007Images := ".\"+cSkinDLL
oCmdGlobSett:Title := "Test 1.0"
oCmdGlobSett:license := cLicense


CJCOMMANDBARS oCommandBars ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
       SCALEMODE xtpScalePixel ;
       PARENT oAppWindow

DCUSEREVENT xbeP_User+111 ACTION {|a,b,o| MenuSelect(a:id,oCommandBars) }

#ifdef WITHTOOLBAR
@0,0 CJTASKPANEL oTaskpanel ;
      SIZE 300, DCGUI_PARENTHEIGHT-2 ;
      PIXEL ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_Y ;
      HOTTRACKSTYLE 3 ;
      VISUALTHEME TP_VisualTheme ;
      ITEMLAYOUT 2 ;
      ENABLEMARKUP ;
      BEHAVIOUR xtpTaskPanelBehaviourExplorer ;
      ANIMATION xtpTaskPanelAnimationYes ;
      EVAL {|o| PanelGroups(o) }
#endif

#ifdef WITHBROWSE
@0,0 DCSAY '' OBJECT oStatic COLOR GRA_CLR_RED, GRA_CLR_WHITE ;
      SIZE 300, 300 FONT '16.Arial Bold' SAYWORDBREAK ;
      SAYOPTIONS XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_WORDBREAK ;
      EVAL {|o|o:setCaption('Tabbed Toolbar Test Program')} ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@50,0 DCBROWSE oBrowse DATA aDir ;
      PARENT oStatic ;
      FONT '10.Lucida Console' ;
      SIZE DCGUI_PARENTWIDTH, DCGUI_PARENTHEIGHT-50 PIXEL ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 250 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'File Size' WIDTH 100 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'File Date' WIDTH 100 PARENT oBrowse
DCBROWSECOL ELEMENT 4 HEADER 'File Time' WIDTH 100 PARENT oBrowse
#endif

DCGETOPTIONS RESIZE PIXEL ;
   CLOSEQUERY MSG {||SaveState(oCommandBars),.t.} ;
   COLOR GRA_CLR_WHITE ;
   HIDE

*   WINDOWHEIGHT 600 ;
*   WINDOWWIDTH 800 ;

DCREAD GUI TITLE "Test Ribbonbar" OPTIONS GetOptions ;
     PARENT @oAppWindow ;
     EVAL {|o|oDlg := o, ;
             BuildTabbedToolBar( oCommandBars, @oTabToolBar, oStatic, oDlg, @nTheme, GetList ), ;
             o:show()}



RETURN nil
* -----------

PROC appsys ; RETURN

* -----------

#define ID_INDICATOR_CAPS           59137
#define ID_INDICATOR_NUM            59138
#define ID_INDICATOR_SCRL           59139


STATIC FUNCTION BuildTabbedToolbar( oCommandBars, oTabToolBar, oStatic, oDlg, nTheme, GetList )

LOCAL oTab, oControl, iCount, cIconPath, oMenuBar, oViewMenuToolbars
LOCAL oFileMenu, oEditMenu, oViewMenu, oStatusBar, oMessageBar
LOCAL oHelpMenu, oThemeMenu, oStyleMenu, aIconArray[5], oOptions, bOption
LOCAL oRibbonBar, oControlFile
local nItemBreitePrg:=90
local nHandle := GetModuleHandleA(0)
local aSystButtItems

oOptions := oCommandBars:getProperty("options")
oOptions:updatePeriod := 0

oRibbonBar := oCommandbars:AddRibbonBar("Ribbonbar1")
oRibbonBar:enableDocking(xtpFlagStretched)
oRibbonBar:enableFrameTheme()
oRibbonBar:ShowQuickAccess:=.T.
oRibbonBar:AllowQuickAccessCustomization:=.F.

oQAccess:=oRibbonBar:QuickAccessControls

oC:=oQAccess:Add( xtpControlButton, 1, "&Help")
oC:Style:=xtpButtonIconAndCaption
oC:iconID := 1

oC:=oQAccess:Add( xtpControlButton, 2, "&Last Changes")
oC:Style:=xtpButtonIconAndCaption
oC:iconID := 2

oC:=oQAccess:Add( xtpControlButton, 3, "&Active User")
oC:Style:=xtpButtonIconAndCaption
oC:iconID := 3

oC:=oQAccess:Add( xtpControlButton, 4, "&about...")
oC:Style:=xtpButtonIconAndCaption
oC:iconID := 4

***************
* Systembutton
***************
oControlSyst := oRibbonBar:AddSystemButton()
oControlSyst:iconID := 1000

aSystButtItems:={ ;
     {"&Local Settings", 5, 5,.T.}, ;
     {"&Printer Settings", 8, 8,.T.}, ;
     {"&Change User", 9, 9,.T.}, ;
     {"&Quit", 999, 999,.F.}  }

for i:=1 to len(aSystButtItems)
   CJLoadIconFromResource aSystButtItems[i][3] HANDLE nHandle ID aSystButtItems[i][3] STATE xtpImageNormal PARENT oCommandBars:icons
   oControl:=oControlSyst:CommandBar:Controls:Add( xtpControlButton, aSystButtItems[i][2], aSystButtItems[i][1] )
   oControl:Width:=200
   oControl:Height:=40
   oControl:Style:=xtpButtonIconAndCaptionBelow
   oControl:iconID := aSystButtItems[i][3]
   oControl:BeginGroup := aSystButtItems[i][4]
next

oTab3 := oRibbonBar:InsertTab(0, "&Data Im-/Export")
oTab2 := oRibbonBar:InsertTab(0, "&Global Settings")
oTab1 := oRibbonBar:InsertTab(0, "&Main program")

oRibbongroup := oTab1:Groups:AddGroup("Programs",1000)
   oControl:=oRibbongroup:Add( xtpControlButton, 1000, "File")
   oControl:Style:=xtpButtonIconAndCaptionBelow
   oControl:iconID := 1
   oControl:Width:=nItemBreitePrg


oRibbongroup := oTab1:Groups:AddGroup("Index Rebuild",50)

oRibbongroup := oTab1:Groups:AddGroup("Communication",100)

oRibbongroup := oTab2:Groups:AddGroup("Program Settings",150)

oRibbongroup := oTab3:Groups:AddGroup("Data Backup",50)


oTab1:selected := .T.


oMenuBar := oCommandBars:ActiveMenuBar

oSBar := oMenuBar:CommandBars:StatusBar()
oSBar:Visible := .T.
oSBar:ShowSizeGripper :=.F.
oSBar:IdleText:=" "
oSBar:EnableMarkup:=.T.

oPane := oSBar:AddPane(0)
oPane:Style := SBPS_STRETCH
oPane:Text  := ""
oPane:Width := 0

oPane := oSBar:AddPane(1)
oPane:Style := SBPS_STRETCH
oPane:Text  := "Wolfgang Ciriack, CiJu GmbH, Berlin"
oPane:Width := 0             // Auto Size

oPane4 := oSBar:AddPane(4)
oPane4:Style := SBPS_STRETCH
oPane4:Text  := "Version: 1.00.1"
oPane4:Width := 0

oSBar:AddPane (ID_INDICATOR_CAPS)
// Adds the special Num lock indicator pane
oSBar:AddPane (ID_INDICATOR_NUM )
// Adds the special Scroll lock indicator pane
oSBar:AddPane (ID_INDICATOR_SCRL)


oCommandBars:execute := {|o|PostAppEvent(xbeP_User+111,o)}

** no Quick Access with that setting
*oCommandBars:EnableCustomization(.T.)

*oCommandBars:update := {|| ResizeDrawingArea(oDlg,.t.,GetList)}

RestoreState(oCommandBars)
oCommandBars:ResizeDrawingArea(oDlg,.t.,GetList)




RETURN nil
* ---------------

* ---------------

STATIC FUNCTION ActionBlock( nId, oCommandBars, oDlg, oStatic )

RETURN {||oStatic:setCaption('You clicked on ' + Alltrim(Str(nId))), ;
          oCommandBars:resizeDrawingArea(oDlg)}

* ---------------

STATIC FUNCTION WhenBlock( i, oCommandBars )

RETURN {||IIF(i%2==0,.t.,.f.)} // disable every 2nd button

* ---------------

STATIC FUNCTION HideBlock( i, oCommandBars )

RETURN {||IIF(i%4==0,.t.,.f.)} // hide every 4th button

* ---------------

STATIC FUNCTION SaveState( oCommandBars )

oCommandBars:SaveCommandBars( 'XCodeJock', 'Tabbed ToolBar Demo','Layout')

RETURN nil

* ---------------

STATIC FUNCTION RestoreState( oCommandBars )

oCommandBars:LoadCommandBars( 'XCodeJock', 'Tabbed ToolBar Demo','Layout')

RETURN nil

* ------------

FUNCTION SetOption( nId, oControl, oCommandBars, oTabToolBar, nTheme )

IF nId == ID_THEME_OFFICE2000
  nTheme := oCommandBars:visualTheme := xtpThemeOffice2000
ELSEIF nId == ID_THEME_OFFICEXP
  nTheme := oCommandBars:visualTheme := xtpThemeOfficeXP
ELSEIF nId == ID_THEME_OFFICE2003
  nTheme := oCommandBars:visualTheme := xtpThemeOffice2003
ELSEIF nId == ID_THEME_NATIVEWINXP
  nTheme := oCommandBars:visualTheme := xtpThemeNativeWinXP
ELSEIF nId == ID_THEME_WHIDBEY
  nTheme := oCommandBars:visualTheme := xtpThemeWhidbey
ELSEIF nId == ID_THEME_OFFICE2007
  nTheme := oCommandBars:visualTheme := xtpThemeOffice2007
ELSEIF nId == ID_THEME_RIBBON
  nTheme := oCommandBars:visualTheme := xtpThemeRibbon
ELSEIF nId == ID_THEME_VISUALSTUDIO2008
  nTheme := oCommandBars:visualTheme := xtpThemeVisualStudio2008
ELSEIF nId == ID_BUTTONSTYLE_CAPTION
  oTabToolBar:defaultButtonStyle := xtpButtonCaption
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_ICON
  oTabToolBar:defaultButtonStyle := xtpButtonIcon
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_ICONANDCAPTION
  oTabToolBar:defaultButtonStyle := xtpButtonIconAndCaption
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_ICONANDCAPTIONBELOW
  oTabToolBar:defaultButtonStyle := xtpButtonIconAndCaptionBelow
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_CAPTIONANDDESCRIPTION
  oTabToolBar:defaultButtonStyle := xtpButtonCaptionAndDescription
  oCommandBars:visualTheme := nTheme
ELSEIF nId == ID_BUTTONSTYLE_AUTOMATIC
  oTabToolBar:defaultButtonStyle := xtpButtonAutomatic
  oCommandBars:visualTheme := nTheme
ENDIF

RETURN nil
***********************************************************
PROCEDURE MenuSelect(nID,oCBar)
local nL:=0, nT:=0, nR:=0, nB:=0
do case
case nID=1
   oCBar:GetWindowRect(@nL,@nT,@nR,@nB)
   DC_WinAlert( str(nL)+":"+str(nT)+":"+str(nR)+":"+str(nB) )

case nID=999
  QUIT
otherwise
   DC_WinAlert("Selected: "+str(nID))
endcase
return
***********************************************
#define TERM_U  1
#define TERM_G  2
#define TERM_F  3
#define TERM_K  4
#Pragma Library("xbtbase1.lib")
***********************************************
STATIC procedure PanelGroups( oTaskPanel)
local nHandle, aT, i, l, p
local oGroup0, oGroup1, oGroup2, oGroup3, oGroup4, oItem
local cMarkup

nHandle := GetModuleHandleA(0)
***************
aT:=GetTermine()
***************
l:=len(aT)

CJTaskPanelGroup oGroup0 CAPTION 'Important' PARENT oTaskPanel EXPANDABLE ON

CJTaskPanelGroup oGroup1 CAPTION 'Vacations' PARENT oTaskPanel EXPANDABLE ON
CJTaskPanelGroup oGroup2 CAPTION 'Birthdays' PARENT oTaskPanel EXPANDABLE ON
CJTaskPanelGroup oGroup3 CAPTION 'Driver Licence' PARENT oTaskPanel EXPANDABLE ON
CJTaskPanelGroup oGroup4 CAPTION 'Vehicle' PARENT oTaskPanel EXPANDABLE ON

for i:=1 to l
   if aT[i][1]=TERM_U
      p:=oGroup1
   elseif aT[i][1]=TERM_G
      p:=oGroup2
   elseif aT[i][1]=TERM_F
      p:=oGroup3
   elseif aT[i][1]=TERM_K
      p:=oGroup4
   else
      p:=oGroup0
   endif

   TEXT INTO cMarkup WRAP
   <StackPanel Margin='10, 0, 0, 3' Orientation="Vertical">
     <TextBlock FontFamily='Arial' FontSize='12pt' Margin='0, 0, 0, 0' HorizontalAlignment="Left" VerticalAlignment='Top' FontWeight='Bold' Foreground='IDCOLOR'>IDDAT</TextBlock>
     <TextBlock FontFamily='Arial' FontSize='10pt' Padding='0, 0, 0, 3' TextWrapping='Wrap'>IDTXT</TextBlock>
   </StackPanel>
   ENDTEXT
   cMarkup:=atrepl("IDCOLOR",cMarkup,iif(aT[i][3]==date(),"Red","Black"))
   cMarkup:=atrepl("IDDAT",cMarkup,iif(aT[i][3]=date(),"T o d a y",substr(ntocdow(dow(aT[i][3])),1,2)+". "+dtoc(aT[i][3]))+iif(aT[i][3]<>aT[i][4]," to "+substr(ntocdow(dow(aT[i][4])),1,2)+". "+dtoc(aT[i][4]),""))
   cMarkup:=atrepl("IDTXT",cMarkup,aT[i][2])

   CJTaskPanelItem oItem ID 10+i CAPTION cMarkup TYPE xtpTaskItemTypeLink PARENT p ;
   ICON 1001 FONT "10.Arial"
next
RETURN
******************************************************************************
static function GetTermine()
local aRet:={}

aadd(aRet,{TERM_U, "Wolfgang Ciriack",date()-1,date()+10} )
aadd(aRet,{TERM_G, "Roger Donnay",date(),date()} )
aadd(aRet,{TERM_K, "B-CU 153 to service",date()+1,date()+1} )
return aRet